package com.javaseleniumtemplate.pages;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;


public class RetiradaDeEstoquePage  extends PageBase{

    //Evento de loading da pagina:
    By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");

    //FILTRO INICIAL:
    By clearFilter = By.xpath("//*[@data-zh-id='176086331530059978752776_filter_action_clear']");
    By IconeUnidade = By.xpath("//div[@id='NMFILIAL']//span[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By SelecioanarUnidadeAjusteIventario = By.xpath("//*[@data-zh-field-name='NMFILIAL']//*[.='HELA INGREDIENTES BRASIL']");
    By btnIconAlmoxarifado1 = By.xpath("//div[@id='DSALMOXARIFE']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By almoxarifado = By.xpath("//span[text()='HELA MATRIZ']");
    By btnXlimparDataRetiradaEstFiltro = By.xpath(" //span[@zh-icon='no-border close-x'and @zh-stop-propagation-click='']");
    By IconeData = By.xpath("//div[@id='INTERVALO']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
    By DataEscolhidaInicial = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");
    By BtnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
    By aplicarFiltro = By.xpath("//span[text()='Aplicar filtro']"); //data-zh-id esta vazio

    //Retirada DE ESTOQUE:
    By btnAdicionar = By.xpath("//*[@id='footer']//*[@data-zh-id='176086331542828469142843']");
    By btnXlimparDatalancamento = By.xpath("//div[@class='zh-select-date zh-field-DTLANCESTQ']//*[@zh-icon='no-border close-x']");
    By IconeData2 = By.xpath("//*[@data-zh-id='176086331536328227812830']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
    By Datalancamento = By.xpath("//div[@class='day today']");

    By setor = By.xpath("//*[@id='NMSETOR']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By setorEscolhido = By.xpath("//span[text()='Administrativo']");

    By tipoRetirada = By.xpath("//*[@data-zh-id='176086331532745039722840']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By itemRetirada = By.xpath("//span[text()='CONSUMO DE PRODUÇÃO']");


    By descricao = By.xpath("//*[@zh-id='176086331540471671592831']");
    By btnAdicionar2 = By.xpath("//span[text()='Adicionar Produtos']");
    By btnAdicionar3 = By. xpath("//*[@id='footer']//*[@data-zh-id='17608633154900707662793']");
    By btnIconProduto = By.xpath("//*[@id='NMPRODUTO']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By produto = By.xpath("//span[text()='SUMO DE LIMAO - CX12 500ML']");

    //Informações Complementares do Produto
    By btnIconLimparAlmoxarifado = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@class='zh-icon zh-icon-close-x zh-icon-no-border']");

    By selectLote = By.xpath("//*[@data-zh-id='7645275172186633453300']//*[@tabindex='0']");
    By loteExistente = By.xpath("//ul[@class='list zh-new-select-list']/li[1]");

    By btnLupaLote = By. xpath("//*[@id='NRLOTEESTQ']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By lote = By.xpath("//span[text()='025/50']");

    By confirmar = By.xpath("//*[@data-zh-id='7645275174220205724322']//*[.='Confirmar']");

    //sub-aba Produtos:
    By campoQuantidade = By.xpath("//*[@zh-id='17608633159797388502786']");
    By campoValorDevolvido = By.xpath("//*[@zh-id='17608633159213244502788']");

    //salvar Item:

    By adicionarItem = By.xpath("//span[text()='Adicionar']");
    By btnSalvar = By.xpath("//span[text()='Salvar']");
    By btnVoltar = By.xpath("//span[text()='Voltar']");


    //Banco
    By numeroLancado = By.cssSelector("span[style*='padding-left: 0px;']:first-child");




    //Editar Retirada
    By btnSelecionarRetirada = By.xpath("//span[text()='Teste Automatizado Retirada de Estoque']");
    By btnEditar = By.xpath("//*[@data-zh-id='17608633158544395752845']");

    //Excluir
    By btnSelecionarItemExclir = By.xpath("//span[text()='Deletar']");
    By btnExcluir = By.xpath("//*[@data-zh-id='17608633154664921452847']");
    By btnSim = By.xpath("//span[text()='Sim']");

    //FILTRO INICIAL:
public void limparFiltro(){
    waitForVisibilityOfElementLocated(clearFilter);
    click(clearFilter);
    waitForInvisibilityOfElementLocated(loadingWait);
}
    //UNIDADE
    public void selecionarUnidade(){
        waitForVisibilityOfElementLocated(IconeUnidade);
        click(IconeUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoBusca(){
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
    }
    public void  buscarUnidade(String descUnidade){
        sendKeys(campoProcurarFloatControl,descUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarUnidadeAjusteInventario(){
        waitForVisibilityOfElementLocated(SelecioanarUnidadeAjusteIventario);
        click(SelecioanarUnidadeAjusteIventario);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //ALMOXARIFADO
    public void clicarCampoAlmoxarifado (){
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado1);
        click(btnIconAlmoxarifado1);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarAlmoxarifado(String descAlmoxarifado){
        sendKeys(campoProcurarFloatControl,descAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarAlmoxarifadoEscolhido(){
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //DATA
    public void limparSomenteCampo(){
        waitForVisibilityOfElementLocated(btnXlimparDataRetiradaEstFiltro);
        click(btnXlimparDataRetiradaEstFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarCampoData(){
        waitForVisibilityOfElementLocated(IconeData);
        click(IconeData);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Data final aparece automaticamente.
    public void selecionarDataInicialFinal(){
        waitForVisibilityOfElementLocated(DataEscolhidaInicial);
        click(DataEscolhidaInicial);
    }
    public void  clicarBotaoOK(){
        waitForVisibilityOfElementLocated(BtnOkFiltro);
        click(BtnOkFiltro); //data-zh-id esta vazio
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //APLICAR FILTRO
    public void AplicarFiltro(){
        waitForVisibilityOfElementLocated(aplicarFiltro);
        click(aplicarFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
 public void  clicarAdicionar(){
     waitForVisibilityOfElementLocated(btnAdicionar);
     click(btnAdicionar);
     waitForInvisibilityOfElementLocated(loadingWait);
 }
    //Sub-aba Retirada de Estoque:
    //Data Retirada
    public void clicarLimparCampoDataLancamento(){
        waitForVisibilityOfElementLocated(btnXlimparDatalancamento);
        click(btnXlimparDatalancamento);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarCampoDataLacamento(){
        waitForVisibilityOfElementLocated(IconeData2);
        click(IconeData2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void escolherDataLancamento(){
        waitForVisibilityOfElementLocated(Datalancamento);
        click(Datalancamento);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //setor
    public void clicarCampoSetor(){
        waitForVisibilityOfElementLocated(setor);
        click(setor);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void buscarSetor(String campoSetor){
        sendKeys(campoProcurarFloatControl,campoSetor);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void selecionarSetor(){
        click(setorEscolhido);
        waitForInvisibilityOfElementLocated(loadingWait);

    }
    //Tipo de Retirada
    public void escolherTipoRetirada(){
        waitForVisibilityOfElementLocated(tipoRetirada);
        click(tipoRetirada);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarProdutoRetirada(String campoRetirada){
        sendKeys(campoProcurarFloatControl,campoRetirada);
        click(itemRetirada);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoDescricao(){
        waitForVisibilityOfElementLocated(descricao);
        click(descricao);
    }
    //Descrição
    public void inserirDescricao(String cmpDesc){
        sendKeys(descricao, cmpDesc);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Adicionar
    public void clicarAdicionarProduto(){
        waitForVisibilityOfElementLocated(btnAdicionar2);
        click(btnAdicionar2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnAdicionar3);
        click(btnAdicionar3);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //Produto
    public void clicarCampoProduto(){
        waitForVisibilityOfElementLocated(btnIconProduto);
        click(btnIconProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void inserirCampoProduto(String descProduto){
        sendKeys(campoProcurarFloatControl,descProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarProduto(){
        waitForVisibilityOfElementLocated(produto);
        click(produto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Campo Informações Complementares do Produto

    public void limparCampoAlmoxarifado(){
        waitForVisibilityOfElementLocated(btnIconLimparAlmoxarifado);
        click(btnIconLimparAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarTipoLote(){
        waitForVisibilityOfElementLocated(selectLote);
        click(selectLote);
    }
    public void selecionarTipoLoteExistente(){
        waitForVisibilityOfElementLocated(loteExistente);
        click(loteExistente);
        //waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarLupaLote(){
        waitForVisibilityOfElementLocated(btnLupaLote);
        click(btnLupaLote);
    }
    public void buscarLote(String DescCampoLote){
        sendKeys(campoProcurarFloatControl,DescCampoLote);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarLoteExistente(){
        waitForVisibilityOfElementLocated(lote);
        click(lote);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //btn confirmar
    public void clicarConfirmar(){
        waitForVisibilityOfElementLocated(confirmar);
        click(confirmar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //sub-aba Produtos
    //Quantidade
    public void clicarCampoQuantidade(String quantidade){
        waitForVisibilityOfElementLocated(campoQuantidade);
        sendKeys(campoQuantidade,quantidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Quantidade devolvida
    public void informarValorDevolvido(String valorDevolvido){
        waitForVisibilityOfElementLocated(campoValorDevolvido);
        sendKeys(campoValorDevolvido,valorDevolvido);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void adiconarItem(){
        waitForVisibilityOfElementLocated(adicionarItem);
        click(adicionarItem);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Salvar Item
    public void clicarSalvar(){
        waitForVisibilityOfElementLocated(btnSalvar);
        click(btnSalvar);
        waitForInvisibilityOfElementLocated(loadingWait);

    }
    //Banco captura
    public void bancoCaptura(){
        //waitForVisibilityOfElementLocated(btnVoltar);
        // click(btnVoltar);
        //waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(numeroLancado);
        click(numeroLancado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //Banco tela de entrada
    public  String retornaNumeroLancamento(){return getText(numeroLancado);}
    public String retornaQuantidadeSolicitada(){return  getText(numeroLancado);}
    public String retornaQuantidadeDevolvida(){return getText(numeroLancado);}
    public String retornaQuantidadeRestante(){return  getText(numeroLancado);}


    public void editarLancamentoRetirada(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnSelecionarRetirada);
        click(btnSelecionarRetirada);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarBotaoEditar(){
        waitForVisibilityOfElementLocated(btnEditar);
        click(btnEditar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoDescricaoEdicao(String campoEditado){
        waitForVisibilityOfElementLocated(descricao);
        clearAndSendKeys(descricao,campoEditado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarBotaoVoltar(){
        waitForVisibilityOfElementLocated(btnVoltar);
        click(btnVoltar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void selecionarItemParaSerDeletado(){
        waitForVisibilityOfElementLocated(btnSelecionarItemExclir);
        click(btnSelecionarItemExclir);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void clicarBotaoExcluir(){
        waitForVisibilityOfElementLocated(btnExcluir);
        click(btnExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void confirmarItemExcluido(){
        waitForVisibilityOfElementLocated(btnSim);
        click(btnSim);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

}