package com.javaseleniumtemplate.pages;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;

public class AjusteInventarioPage extends PageBase {

    //Evento de loading da pagina:
        By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:

        By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");

    //Aplicando os paramentros no Filtro inicial:
        By clearFilter = By.xpath("//*[@data-zh-id='2085279469498787152459_filter_action_clear']");
        By IconeUnidade = By.xpath("//*[@data-zh-id='208527946922898167425048']//*[@id='NMFILIAL']/span[1]");
        By SelecioanarUnidadeAjusteIventario = By.xpath("//*[@data-zh-field-name='NMFILIAL']//*[.='HELA INGREDIENTES BRASIL']");
        By IconeData = By.xpath("//*[@data-zh-id='208527946925069924912507']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEscolhidaInicial = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");
        By BtnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
        By IconeOperador = By.xpath("//*[@data-zh-id='208527946916820554232513']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By codOperador = By.xpath("//*[@id='grid-9000']//*[.='000000218419']");
        By aplicarFiltro = By.xpath("//*[@data-zh-id='2085279469498787152459_filter_action_never']//span[text() = 'Aplicar filtro']"); //data-zh-id esta vazio

    //Adicionando Ajuste de inventario:
        By btnAdicionar = By.xpath("//*[@id='footer']//*[@data-zh-id='208527946931600053562520']");
        By btnAdicionar2 = By.xpath("//*[@data-zh-id='20852794697104433322483']");
        By caixaTextoAjusteIventario = By.xpath("//*[@class='zh-text-alert']");//Nao precisa de data-zh-id
        By btnOkAlert = By.xpath("//*[@class='zh-container-alert']//*[@data-zh-id='zh-footer-alert-button-0']");
        By btnXlimpar = By.xpath("//*[@data-zh-id='208527946925069924912507']//*[@zh-icon='no-border close-x']");
        By btnCalendario = By.xpath("//*[@data-zh-id='208527946925069924912507']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEscolhida = By.xpath("//div[@class='day today']");//Nao precisa de data-zh-id
        By campoDescricao = By.xpath("//*[@zh-id='208527946936254289722511']");
        By btnSalvar = By.xpath("//*[@data-zh-id='208527946937190993162526']");
        By btnIcon = By.xpath("//*[@data-zh-id='208527946917703242502463']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By produto = By.xpath("//*[@id='grid-9000']//*[.='Hela Poultry Broth Paste Clear KG']");//Nao precisa de data-zh-id
        By btnXlimpar2 = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@id='DSALMOXARIFE']/span[2]");
        By btnIconAlmoxarifado = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By almoxarifado = By.xpath("//*[@id='grid-9000']//*[.='HELA MATRIZ']");//Nao precisa de data-zh-id
        By confirmar = By.xpath("//*[@data-zh-id='7645275174220205724322']//*[.='Confirmar']");
        By btnIconLote = By.xpath("//*[@data-zh-id='7645275171631791325304']");

        By selectLote = By.xpath("//*[@data-zh-id='7645275172186633453300']//*[@tabindex='0']");
        By loteExistente = By.xpath("//ul[@class='list zh-new-select-list']/li[1]");

        By btnLupaLote = By. xpath("//*[@id='NRLOTEESTQ']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By lote = By.xpath("//span[text()='00231100']");//Nao precisa de data-zh-id
        By quantidadeProduto = By.xpath("//*[@zh-id='208527946938333229262469']");
        By btnSalvar2 = By.xpath("//span[text()='Salvar']");


        By btnConfirmarEstoque = By.cssSelector("div > #footer > .zh-footer-right .zh-footer-title-sprit");
        By btnAtualizarEstoque = By.xpath("//span[text()='Atualizar Estoque']");

        By btnGravar = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");
        By caixaTextoEstoqueAtualizadoComSucesso = By.xpath("//*[@class='zh-container-alert']");//Nao precisa de data-zh-id
        By BtnOk = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");

    //EDITAR AJUSTE IVENTARIO:
        By localizandoDescricao = By.xpath("//span[text()='Teste Automatizado']");
        By btnEditar = By.xpath("//*[@id='footer']//*[@data-zh-id ='208527946928758746902516']");
        By btnSim = By.xpath("//*[@class='zh-container-alert']//*[@data-zh-id='zh-footer-alert-button-0']");
        By campoDescricao2 = By.xpath("//*[@zh-id='208527946936254289722511']");
        By abaProduto = By.xpath("//*[@data-zh-id='masterDetailTabbedWidget']//li[2]/label");
        By btnAdicionar3 = By.xpath("//*[@data-zh-id='20852794697104433322483']");
        By btnIconSearch = By.xpath("//*[@data-zh-id='208527946917703242502463']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By produto2 = By.xpath("//*[@id='grid-9000']//*[.='Ochsenbuillon Paste (Hela 7565810050001)']");
        By lote2 = By.xpath("//span[text()='20013001']");//Nao precisa de data-zh-id

        By btnValidade = By.xpath("//*[@data-zh-id='76452751786488369316']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By dataValidade = By.xpath("//div[@class='day today']");


        By clickCampoQuantidade = By.id("QTTOTLANCTO");
        By btnAtualizarEstoqueEditado = By.xpath("//span[text()='Atualizar Estoque']");
        By btnSalvarAlteracoes = By.xpath("//span[text()='Salvar alterações']");
        By btnEstoqueAtualizadoComSucesso = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");
        By btnVoltar = By.xpath("//span[text()'Voltar']");

    //EXCLUIR AJUSTE INVENTARIO:
        By localizandoDescricaoExcluir = By.xpath("//span[text()='Deletar']");
        By btnExcluir = By.xpath("//*[@id='footer']//*[@data-zh-id ='208527946938725575942522']");
        By AlertExcluirRegistro = By.xpath("//*[@class='zh-container-alert']//*[@class='zh-container-text-alert']");

    //Importar Ajuste de inventario:
       By btnImportar = By.xpath("//*[@id='footer']//*[@data-zh-id='20852794691123972999134']");
       By btnEscolherArquivo = By.xpath("//*[@data-zh-id='20852794693995615714784']//*[@id='UPLOADFILE_button']");

    //Banco

    By numerolancado = By.cssSelector("#span-field-NRLANCESTQ > .zh-field-value");
    By voltar = By.xpath("//span[text()='Voltar']");

//Filtro incial
    public void limparTela(){
        click(clearFilter);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarIconeUnidade(){
        waitForVisibilityOfElementLocated(IconeUnidade);
        click(IconeUnidade);
    }

//Busca por unidade
    public void campoBusca(){
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
    }
    public void buscarUnidade(String descUnidade){
        sendKeys(campoProcurarFloatControl,descUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarUnidadeInventario(){
        waitForVisibilityOfElementLocated(SelecioanarUnidadeAjusteIventario);
        click(SelecioanarUnidadeAjusteIventario);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarCampoData(){
        waitForVisibilityOfElementLocated(IconeData);
        click(IconeData);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarPeriodo(){
        waitForVisibilityOfElementLocated(DataEscolhidaInicial);
        click(DataEscolhidaInicial);
    }
    public void confimrarDataEscolhida(){
        waitForVisibilityOfElementLocated(BtnOkFiltro);
        click(BtnOkFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarCampoOperador(){
        waitForVisibilityOfElementLocated(IconeOperador);
        click(IconeOperador);
    }
    public void buscarOperador(String descOperador){
        sendKeys(campoProcurarFloatControl,descOperador);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void codigoOperador(){
        waitForVisibilityOfElementLocated(codOperador);
        click(codOperador);
    }
    public void clicarAplicarFiltro(){
        waitForVisibilityOfElementLocated(aplicarFiltro);
        click(aplicarFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);

    }


    //Adicionando item
    public void clicarAdicionar(){
        waitForVisibilityOfElementLocated(btnAdicionar);
        click(btnAdicionar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarAlertCaixaTextoAjusteInventario(){
        waitForVisibilityOfElementLocated(caixaTextoAjusteIventario);
        waitForVisibilityOfElementLocated(btnOkAlert);
        click(btnOkAlert);
    }
    public void limparData() {
    waitForVisibilityOfElementLocated(btnXlimpar);
    click(btnXlimpar);
}
    public void clicarCampoCalendario(){
        waitForVisibilityOfElementLocated(btnCalendario);
        click(btnCalendario);
    }
    public void selecionarDataEscolhida(){
        waitForVisibilityOfElementLocated(DataEscolhida);
        click(DataEscolhida);
    }
    public void  campoDescricao(String cmpDesc){
        waitForVisibilityOfElementLocated(campoDescricao);
        click(campoDescricao);
        sendKeys(campoDescricao,cmpDesc);
    }
    public void clicarBotaoSalvar(){
        waitForVisibilityOfElementLocated(btnSalvar);
        click(btnSalvar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarAbaProduto(){
        waitForVisibilityOfElementLocated(btnAdicionar2);
        click(btnAdicionar2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarCampoProduto(){
        waitForVisibilityOfElementLocated(btnIcon);
        click(btnIcon);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buscarProduto(String descProduto){
        sendKeys(campoProcurarFloatControl,descProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarProduto(){
        waitForVisibilityOfElementLocated(produto);
        click(produto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void limparCampoAlmoxarifado(){
        waitForVisibilityOfElementLocated(btnXlimpar2);
        click(btnXlimpar2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarIconeAlmoxarifado(){
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado);
        click(btnIconAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buscarAmoxarifado(String descAlmoxarifado){
        sendKeys(campoProcurarFloatControl,descAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarAlmoxarifado(){
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);

    }
    public void clicarBotaoLote(){
        waitForVisibilityOfElementLocated(btnLupaLote);
        click(btnLupaLote);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void pesquisarLote(String descLote){
        sendKeys(campoProcurarFloatControl,descLote);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarLote(){
        click(lote);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarConfirmar(){
        waitForVisibilityOfElementLocated(confirmar);
        click(confirmar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarCampoQuantidade(){
        waitForVisibilityOfElementLocated(quantidadeProduto);
        click(quantidadeProduto);
    }
    public void inserirQuantidade(String quantidade){
        sendKeys(quantidadeProduto,quantidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarSalvar(){
        waitForVisibilityOfElementLocated(btnSalvar2);
        click(btnSalvar2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void confirmarEstoque(){
        waitForVisibilityOfElementLocated(btnConfirmarEstoque);
        click(btnConfirmarEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarAtualizarEstoque(){
        waitForVisibilityOfElementLocated(btnAtualizarEstoque);
        click(btnAtualizarEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void gravarAjusteInventario(){
        waitForVisibilityOfElementLocated(caixaTextoAjusteIventario);
        waitForVisibilityOfElementLocated(btnGravar);
        click(btnGravar);
    }
    public void estoqueAtualizadoComSucesso(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(caixaTextoEstoqueAtualizadoComSucesso);
        waitForVisibilityOfElementLocated(BtnOk);
        click(BtnOk);
    }

    public void capturarValorBanco(){
        waitForVisibilityOfElementLocated(localizandoDescricao);
        click(localizandoDescricao);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(numerolancado);
        click(numerolancado);

        //waitForVisibilityOfElementLocated(voltar);
        //click(voltar);
    }

    public String retornaNumeroLacamento(){
        return  getText(numerolancado);
    }

//Editar Ajuste de Inventario
    public void  localizarAjusteInventarioCriado(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(localizandoDescricao);
        click(localizandoDescricao);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarBotaoEditar(){
        waitForVisibilityOfElementLocated(btnEditar);
        click(btnEditar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarCampoDescricaoELimpar(){
        waitForVisibilityOfElementLocated(campoDescricao2);
        click(campoDescricao2);
        clear(campoDescricao2);
    }
    public void inserirNovaDescricao(String cmpDesc2){
        sendKeys(campoDescricao2,cmpDesc2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void adicionarOutroProduto(){
        waitForVisibilityOfElementLocated(btnAdicionar3);
        click(btnAdicionar3);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarLupa(){
        waitForVisibilityOfElementLocated(btnIconSearch);
        click(btnIconSearch);
    }
    public void buscarNovoProduto(String descProduto2){
        sendKeys(campoProcurarFloatControl,descProduto2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarProdutoAdicionado(){
        waitForVisibilityOfElementLocated(produto2);
        click(produto2);
    }

    public void limparAlmoxarifado(){
        waitForVisibilityOfElementLocated(btnXlimpar2);
        click(btnXlimpar2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarBotaoAlmoxarifado(){
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado);
        click(btnIconAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buscarProdutoAlmoxarifado(String descAlmoxarifado){
        sendKeys(campoProcurarFloatControl, descAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarAlmoxarifadoEdicao(){
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Selecionar Lote
    public void clicarCampoLote(){
        waitForVisibilityOfElementLocated(selectLote);
        click(selectLote);
    }
    public void selecionarLoteExistente(){
        waitForVisibilityOfElementLocated(loteExistente);
        click(loteExistente);
    }
    public void clicarBotaoLupaLote(){
        waitForVisibilityOfElementLocated(btnLupaLote);
        click(btnLupaLote);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void buscarSegundoLote(String descLote2){
        sendKeys(campoProcurarFloatControl, descLote2);
        click(lote2);
        waitForInvisibilityOfElementLocated(loadingWait);

    }
    public void selecionarLoteEditado(){
        click(lote2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Quantidade:
    public void quantidadeNovoProduto(String quantidade2){
        sendKeys(quantidadeProduto, quantidade2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
  public void clicarAbaProdutoEdicao(){
      waitForInvisibilityOfElementLocated(loadingWait);
      waitForVisibilityOfElementLocated(abaProduto);
      click(abaProduto);
      waitForInvisibilityOfElementLocated(loadingWait);
  }

    public void localizarAjusteParaDeletar(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(localizandoDescricaoExcluir);
        click(localizandoDescricaoExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarExcluir(){
        waitForVisibilityOfElementLocated(btnExcluir);
        click(btnExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void mensagemAlerta(){
        waitForVisibilityOfElementLocated(AlertExcluirRegistro);
        waitForVisibilityOfElementLocated(btnSim);
        click(btnSim);
    }
    public void alertaAposExluir(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(AlertExcluirRegistro);
        waitForVisibilityOfElementLocated(btnOkAlert);
        click(btnOkAlert);
    }
    public void clicarBotaoImportar(){
        waitForVisibilityOfElementLocated(btnImportar);
        click(btnImportar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void escolherArquivo(){
        waitForVisibilityOfElementLocated(btnEscolherArquivo);
        click(btnEscolherArquivo);
    }

}
